// 在main.js上通过import引入Vue库和自己写的Vue组件库
import Vue from "vue";
import "vant/lib/index.css";
import { Tab, Tabs } from 'vant';
import { DatetimePicker } from 'vant';
import { Popup } from 'vant';
import { Image as VanImage } from 'vant';
import { Col, Row } from 'vant';
import { ActionSheet } from "vant";

Vue.use(Col);
Vue.use(Row);
Vue.use(Tab);
Vue.use(Tabs);
Vue.use(DatetimePicker);
Vue.use(Popup);
Vue.use(VanImage);
Vue.use(ActionSheet);

import DataStatisticsDetail from "./components/dataStatisticsDetail.vue";
import eventBus from "../../../../../../util/eventBus";
(function (KDApi) {
  function MyComponent(model) {
    this._setModel(model);
  }

  MyComponent.prototype = {
    _setModel: function (model) {
      this.model = model;
    },
    init: function (props) {
      console.log("===init===", this.model, props);
      setHtml(this.model, props);
    },
    update: function (props) {
      console.log("===update===", this.model, props);
      eventBus.pub(this.model, "update", props);
    },
    destoryed: function () {
      console.log("===destoryed===", this.model);
      eventBus.unsub(this.updateSub);
    },
  };

  const setHtml = (model, props) => {
    const { invoke } = model;

    KDApi.loadFile("./css/index.css", model, () => {
      new Vue({
        el: model.dom,
        template: `<DataStatisticsDetail />`,
        components: {
          DataStatisticsDetail,
        },
        data: function () {
          return {
            
          };
        },
        mounted() {
          let self = this;
          this.updateSub = eventBus.sub(model, "update", (data) => {
            self.initData(data);
          });
          self.initData(props);
        },
        methods: {
          //后端传递的数据
          initData(props) {
            if (props && props.data) {
              this.handleData(props.data);
            } else {
              
            }
          },
          handleData(data) {
            console.log("==data==", data);
            let tempData = {};
            //type 1是客户数据  2是队伍数据  3是行为数据
            switch (data.pageType) {
              case '1':
                tempData = {
                  pageType:1
                };
                break;
              case '2':
                tempData = {
                  pageType:2
                };
                break;
              case '3':
                tempData = {
                  pageType:3
                };
                break;
                case '4':
                tempData = {
                  pageType:4
                };
                break;
            }

            eventBus.pubCustom(
              "dataStatistics_detailData",
              "detailData",
              tempData
            );
          },
          //发送数据给后端
          invoke: function (eventName, args) {
            invoke(eventName, args);
          },
          
        },
      });
    });
  };

  // 注册自定义组件
  KDApi.register("dataStatisticsDetailKy", MyComponent);
})(window.KDApi);
